/*
 * Configuration.cs
 * $Id: Configuration.cs 13 2004-11-14 17:12:03Z altba\tomoyo $
 * 
 */

using System;
using System.Drawing;
using System.Windows.Forms;
using System.Collections.Specialized;
using System.ComponentModel;

using Misuzilla.Utilities;

namespace MacFace.FloatApp
{
	/// <summary>
	/// Configuration ̊Tv̐łB
	/// </summary>
	public class Configuration
	{
		public static readonly String ConfigurationPath;
		private static Configuration _configInstance = null;

		private StringDictionary _config = new StringDictionary();


		//
		// vpeBɂׂȋC邯ǂƂ肠tB[hŁB
		//
		[AutoConfigure("general.facedefpath")]
		[Category("S"), Description("O񗘗pĂp^[̃fBNg")]
		public String FaceDefPath;

		[AutoConfigure("form.faceform.opacity")]
		[Category("tH["), Description("x0-100̒Ŏw肵܂B")]
		public Int32 Opacity = 100;

		[AutoConfigure("form.faceform.point")]
		[Category("tH["), Description("\ʒu")]
		public Point Location;

		[AutoConfigure("form.faceform.transparentmousemessage")]
		[Category("tH["), Description("}EXbZ[W𓧉߂邩ǂw肵܂B")]
		public bool TransparentMouseMessage;

		public static Configuration GetInstance()
		{
			if (_configInstance == null) 
				_configInstance = new Configuration();

			return _configInstance;
		}
		private Configuration()
		{
			FaceDefPath = System.IO.Path.Combine(Application.StartupPath, "default.mcface");
		}
		static Configuration()
		{
			ConfigurationPath = Environment.GetFolderPath(Environment.SpecialFolder.ApplicationData) + "\\MacFace";
		}


		// ۑAǂݍ
		public void Load()
		{
			// StringDictionaryvpeBւǂB
			_config = Setting.GetSettings(ConfigurationPath + @"\AppSettings.xml");
			AutoConfigurator.Configure(this,
					new AutoConfigurator.ConfigurationHandler(LoadConfigHandler));
		}

		public void Save()
		{
			if (!System.IO.Directory.Exists(ConfigurationPath))
				System.IO.Directory.CreateDirectory(ConfigurationPath);
			
			// vpeBStringDictionaryɊi[B
			AutoConfigurator.GetConfiguration(this,
				new AutoConfigurator.GetConfigurationHandler(SaveConfigHandler));

			// XML ɏoB
			Setting.SaveSettings(ConfigurationPath + @"\AppSettings.xml", _config);

		}



		#region AutoConfiguration Handlers
		//
		// SaveŌĂяonh
		//
		private void SaveConfigHandler(String key, Object value, Type propertyType)
		{
			TypeConverter tconv = TypeDescriptor.GetConverter(propertyType);
			_config[key] = tconv.ConvertToString(value);
		}

		//
		// LoadŌĂяonh
		// HashtableStringTypeConverterŌ̌`ɖ߂B(IɃvpeBɃZbg)
		//
		private Object LoadConfigHandler(String key, Type propertyType)
		{
			if (!_config.ContainsKey(key)) return null;

			TypeConverter tconv = TypeDescriptor.GetConverter(propertyType);
			try
			{
				Object o = tconv.ConvertFromString(_config[key] as String);
				return o;
			} 
			catch (NotSupportedException) 
			{
				return null;
			}
		}
		#endregion

	}
}
